<template>
  <div class="fr-container fr-p-5w">
    <TheHeader title="Gérer les utilisateurs" />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main class="main-container fr-p-5w">
          <UserTable
            :roles="roles"
            :users="users"
            :pending="usersPending"
            :error="usersError"
          />
          <button
            class="fr-btn fr-btn--secondary fr-btn--icon-left fr-icon-question-line fr-mb-3w fr-mt-1w"
            aria-expanded="false"
            aria-controls="roles-details"
          >
            En savoir plus sur les rôles et habilitations
          </button>
          <RoleTable id="roles-details" />
          <hr />
          <UserForm
            :roles="roles"
            :pending="rolesPending"
            :error="rolesError"
            @users-refresh="usersRefresh"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { errorResponseMessage } from '~/utils/errorResponse'
  import { getRandomId } from '~/utils/random'

  definePageMeta({ middleware: 'can-add-users' })

  const { $apiRequest } = useNuxtApp()

  const {
    data: users,
    pending: usersPending,
    refresh: usersRefresh,
    error: usersError
  } = useLazyAsyncData(getRandomId('users'), loadUsers, {
    server: false
  })

  const {
    data: roles,
    pending: rolesPending,
    error: rolesError
  } = useLazyAsyncData('roles', loadRoles, { server: false })

  async function loadUsers() {
    const res = await $apiRequest(
      '/users',
      {},
      {
        fields: [
          'id',
          'email',
          'first_name',
          'last_name',
          'role.id',
          'role.name',
          'aidant_connect_authorisation',
          'status'
        ],
        sort: [{ field: 'role.name' }]
      }
    )

    if (res.status !== 200) throw new Error(errorResponseMessage(res))
    return res.data.data
  }

  async function loadRoles() {
    const res = await $apiRequest(
      '/roles',
      {},
      {
        fields: ['id', 'name'],
        filter: { admin_access: { _neq: true } }
      }
    )

    // Use ok for type inferrence
    if (res.status !== 200) throw new Error(errorResponseMessage(res))

    return res.data.data
  }
</script>
